import React, { CSSProperties, ReactNode, Ref } from 'react';
import Typeahead from '../core/Typeahead';
import { Align } from './Overlay';
import { RenderMenuItemChildren, TypeaheadMenuProps } from './TypeaheadMenu';
import { Size } from '../constants';
import { InputProps, Option, RenderToken, TypeaheadProps, TypeaheadManagerChildProps } from '../types';
interface RenderMenuProps extends Omit<TypeaheadMenuProps, 'labelKey' | 'options' | 'renderMenuItemChildren' | 'text'> {
    renderMenuItemChildren?: RenderMenuItemChildren;
}
export interface TypeaheadComponentProps extends TypeaheadProps {
    align?: Align;
    className?: string;
    clearButton?: boolean;
    disabled?: boolean;
    dropup?: boolean;
    emptyLabel?: ReactNode;
    flip?: boolean;
    instanceRef?: Ref<Typeahead>;
    isInvalid?: boolean;
    isLoading: boolean;
    isValid?: boolean;
    maxHeight?: string;
    newSelectionPrefix?: ReactNode;
    paginationText?: ReactNode;
    positionFixed?: boolean;
    renderInput?: (inputProps: InputProps, props: TypeaheadManagerChildProps) => JSX.Element;
    renderMenu?: (results: Option[], menuProps: RenderMenuProps, state: TypeaheadManagerChildProps) => JSX.Element;
    renderMenuItemChildren?: RenderMenuItemChildren;
    renderToken?: RenderToken;
    size?: Size;
    style?: CSSProperties;
}
declare const _default: React.ForwardRefExoticComponent<TypeaheadComponentProps & React.RefAttributes<Typeahead>>;
export default _default;
